<?php

namespace Plugins\Ccm19Imex\Event;

use App\Event\FilterEvent;
use App\Model\User;

/**
 * Event beim Exportieren eines Kunden, nachdem die Daten der
 * Kern-Models zusammengetragen wurden.
 *
 * Wird im Kontext des zu exportierenden Benutzers ausgeführt.
 *
 * @phan-inherits FilterEvent<array>
 */
final class ExportClientEvent extends FilterEvent
{
	const NAME = 'ccm19.plugin.ccm19imex.exportclient';

	/** @var User $client */
	private $client;

	public function __construct(User $client, array $data)
	{
		$this->client = $client;
		parent::__construct($data);
	}

	/**
	 * @param string $key
	 * @param mixed $value
	 * @return $this
	 */
	public function set(string $key, $value): self
	{
		$this->returnValue[$key] = $value;
		return $this;
	}

	/**
	 * @return User
	 */
	public function getClient(): User
	{
		return $this->client;
	}
}
