<?php

namespace Plugins\Ccm19Payment\Controller;

use App\Component\HttpFoundation\JavascriptResponse;
use App\Controller\ExternalController;
use App\Model\PluginState;
use App\Utils;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;


/**
 * Controller for payment - domain dependent
 * @Route("/payment/", name="app_ccm19payment_")
 */
class PaymentExternalJS extends ExternalController
{
	/**
	 * @Route("payment.js", name="js")
	 * @return Response
	 */
	public function index(PluginState $state): Response
	{
		//check if is activated
		if (!$state->isActiveForCurrentDomain()) {
			//Nope - then go to dashboard...
			return new Response('JSFile not active.', 404);
		}
		$response = new JavascriptResponse();
		$response->headers->set('X-Robots-Tag', 'noindex, nofollow');

		// Workaround: HTTP-Header Cache-Control würde sonst auf private, must-revalidate etc. gesetzt
		Utils::resetCacheControl($response);

		//Render template with all Data
		return $this->render('@plugin:Ccm19Payment/external/ExternalJs.js.twig', [], $response);
	}

}
?>
