<?php

namespace Plugins\Ccm19Payment\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use App\Event\TemplateRenderEvent;
use App\Model\User;
use App\Utils;
use Plugins\Ccm19Payment\Controller\Payment;

class BackendContent implements EventSubscriberInterface
{
	/**
	 * @return array
	 */
	public static function getSubscribedEvents()
	{
		return [
			TemplateRenderEvent::nameForView('domain/index.html.twig') => ['onRenderDomainIndex', 100],
		];
	}

	/**
	 * @return void
	 */
	public function onRenderDomainIndex(TemplateRenderEvent $event)
	{
		if (Utils::mayUserAccessRoute(User::loggedInUser(), 'app_ccm19payment_admin', 'POST')) {
			$tarifBlock = Payment::getTarifBlock(
				$event->get('maxCallCount'),
				$event->get('maxWLCount'),
				$event->get('getMaxDomainCount')
			);

			$event->extendTemplate('@plugin:Ccm19Payment/internal/domain_index.html.twig');
			$event->set('tarifBlock', $tarifBlock);
			$event->set('hbClient', Payment::getHbClientID());
			$event->set('cancelURLHB', "https://hb-marketplace.com/");
		}
	}
}