<?php

namespace Plugins\Ccm19Payment\EventSubscriber;

use App\Component\Menu\Model\MenuItem;
use App\Event\MenuGenerationEvent;
use App\Utils;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class MenuInjection implements EventSubscriberInterface
{
	/**
	 * @return array
	 */
	public static function getSubscribedEvents()
	{
		return [
			MenuGenerationEvent::NAME => ['onMenuGeneration', 100],
		];
	}

	/**
	 * @return void
	 */
	public function onMenuGeneration(MenuGenerationEvent $event)
	{
		$manager = $event->getMenuManager();

		if(Utils::isMultiDomainEdition() || Utils::isCCMCloud())
		{
			if(!Utils::isClickskeksCloud())
			{
				$manager->addMenuItem('Account Settings', new MenuItem(
					'Manage Rates', 'fa-shopping-cart', ['user'], 'meta', 'app_ccm19payment_admin', 'app_ccm19payment_', 20
				));
			}
		}
	}
}
