<?php

namespace Plugins\Ccm19ScriptPlaceholder\EventSubscriber;

use App\Event\CacheResetEvent;
use Plugins\Ccm19ScriptPlaceholder\Model\Placeholder;
use Plugins\Ccm19ScriptPlaceholder\Model\Snippet;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class CacheReset implements EventSubscriberInterface
{
	public static function getSubscribedEvents(): array
	{
		return [
			CacheResetEvent::NAME => ['onCacheReset', 1000],
		];
	}

	public function onCacheReset(CacheResetEvent $event): void
	{
		$event
			->addRelevantModel(Placeholder::class)
			->addRelevantModel(Snippet::class)
		;
	}
}
