<?php

namespace Plugins\Ccm19ScriptPlaceholder\EventSubscriber;

use App\Event\WidgetPluginsInitEvent;
use App\Model\PluginState;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class WidgetPluginsInit implements EventSubscriberInterface
{
	/** @var PluginState $pluginState */
	private $pluginState;

	public function __construct(PluginState $pluginState)
	{
		$this->pluginState = $pluginState;
	}

	public static function getSubscribedEvents(): array
	{
		return [
			WidgetPluginsInitEvent::NAME => ['onWidgetPluginsInit', 1000],
		];
	}

	public function onWidgetPluginsInit(WidgetPluginsInitEvent $event): void
	{
		// Don't include the plugin into the banner code if the trial period has expired
		if ($this->pluginState->trialIsExpired()) {
			return;
		}

		if ($this->pluginState->isActiveForCurrentDomain()) {
			$event->setPluginScript('plugin_ccm19_script_placeholder_front_main_javascript_file');
		}
	}
}
