<?php

namespace Plugins\Ccm19SingleSignOn\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use App\Event\TemplateRenderEvent;
use App\Model\PluginState;
use App\Model\User;
use App\Utils;
use Plugins\Ccm19SingleSignOn\Model\Provider;

class LoginInjection implements EventSubscriberInterface
{
	private $pluginId;

	public function __construct(PluginState $state)
	{
		$this->pluginId = $state->getPluginUID();
	}

	/**
	 * @return array
	 */
	public static function getSubscribedEvents()
	{
		return [
			TemplateRenderEvent::nameForView('login/index.html.twig') => ['onRenderLogin', 900],
		];
	}

	/**
	 * @return void
	 */
	public function onRenderLogin(TemplateRenderEvent $event)
	{
		$event->set('ssoProviders', Provider::allActive());

		$event->extendTemplate('@plugin:Ccm19SingleSignOn/login_extension.html.twig');
	}

}
