#!/usr/bin/env php
<?php

$data = file_get_contents('https://mds3.fidoalliance.org/blob.jwt');
// Todo: Validate signature
$data = strtr(explode('.', $data, 3)[1], '-_', '+/');
$data = json_decode(base64_decode($data), true);

$entries = [];
$aliases = [];

foreach ($data['entries'] as $entry) {
	$result = [
		"aaguid" => $entry['aaguid'] ?? null,
		'attestationCertificateKeyIdentifiers' => $entry['attestationCertificateKeyIdentifiers'] ?? [],
		"description" => $entry['metadataStatement']['description'] ?? null,
		"descriptionsTranslated" => $entry['metadataStatement']['alternativeDescriptions'] ?? [],
		"tcDisplay" => $entry['metadataStatement']['tcDisplay'] ?? [],
		"keyProtection" => $entry['metadataStatement']['keyProtection'] ?? [],
		"attachmentHint" => $entry['metadataStatement']['attachmentHint'] ?? [],
		"transportsHint" => $entry['metadataStatement']['authenticatorGetInfo']['transports'] ?? [],
	];

	if ($result['aaguid'] !== null) {
		$key = strtr($result['aaguid'], ['-' => '']);
		$entries[$key] = $result;

		foreach ($result['attestationCertificateKeyIdentifiers'] as $kid) {
			$aliases[$kid] = $key;
		}
	}
	else {
		foreach ($result['attestationCertificateKeyIdentifiers'] as $i => $kid) {
			if ($i == 0) {
				$entries[$kid] = $result;
			} else {
				$aliases[$kid] = $result['attestationCertificateKeyIdentifiers'][0];
			}
		}
	}
}

chdir(dirname($_SERVER['argv'][0]));
chdir("../share");
file_put_contents(
	"fido-devices.json",
	json_encode([
		"no" => $data["no"],
		"nextUpdate" => $data["nextUpdate"],
		"devices" => $entries,
		"aliases" => $aliases,
	])
);
