'use strict';

(function () {
	function onDeleteClick (){
		var $row = $(this).closest('tr');
		var $form = $row.closest('form');
		if (this.hasAttribute('data-id')) {
			var $input = $('<input type="hidden" />').prop('name', 'delete_asset[]').prop('value', this.getAttribute('data-id'));
			$input.appendTo($form);
		}
		if ($row.is(':last-child')) {
			$row.find('input:not([type="checkbox"])').prop('value', '');
			$row.find('.delete-button').prop('disabled', true);
		} else {
			$row.fadeOut(250, function () {
				var index = $row.index();
				$('.asset-table tbody > tr:nth-child('+(index+1)+')').remove();
			})
		}
	}

	var appendCounters = $.map($('.asset-table'), function(a){return 0});

	// Bei Blur, ggf neue Zeile am Ende einfügen
	function onNewPlaceholderBlur() {
		var hasContent = !!this.value;
		var $row = $(this).closest('tr');
		var isLastChild = $row.is(':last-child');
		var $button = $row.find('.delete-button').prop('disabled', !hasContent && isLastChild);
		var $tbody = $row.closest('tbody');
		if (hasContent && isLastChild) {
			var tableIndex = $('.asset-table').index($tbody.closest('.asset-table')[0]);
			var $newRow = $newRowTemplate.eq(tableIndex).clone(true).appendTo($tbody);
			$newRow.find('.delete-button').prop('disabled', true);
			appendCounters[tableIndex]++;
			$newRow.find('label, input, select, textarea').each(function () {
				if (this.id) {
					this.id = this.id.replace('[0]', '['+appendCounters[tableIndex]+']');
				}
				if (this.name) {
					this.name = this.name.replace('[0]', '['+appendCounters[tableIndex]+']');
				}
				if (this.hasAttribute('for')) {
					this.setAttribute('for', this.getAttribute('for').replace('[0]', '['+appendCounters[tableIndex]+']'));
				}
			});
		}
	}

	// Werte gemeinsamer Attribute aus den Übersetzungs-Tabs übertragen
	$('.asset-table').on('click blur input', 'input,select,textarea', function (evt) {
		var $table = $(this).closest('.asset-table');
		var $tr = $(this).closest('tr');
		var index = $table.find('input,select,textarea').index(this);
		var input = this;

		$('.asset-table').not($table).each(function () {
			var target = $(this).find('input,select,textarea').eq(index)[0];
			if (target) {
				if (target.name == '' || input.name == '') {
					target.value = input.value;
					target.checked = input.checked;
					if ($tr.hasClass('new-item') && (evt.type == 'blur' || evt.type == 'focusout') && $tr.find('td:first-child input')[0] == input) {
						onNewPlaceholderBlur.call(target);
					}
				}
			}
		});
	});

	// Bei Input-Check Fehlermeldung für Platzhalter ändern
	function onPlaceholderInvalid(evt)
	{
		evt.target.setCustomValidity("");
	};
	function onPlaceholderInput(evt) {
		evt.target.setCustomValidity("");
	};

	// Event-Handler
	$('.delete-button').on('click', onDeleteClick);
	$('.new-item > td:first-child input').on('blur', onNewPlaceholderBlur).on('invalid', onPlaceholderInvalid).on('input', onPlaceholderInput).on('keyup', onPlaceholderInput);

	// Zeile als Vorlage speichern
	var $newRowTemplate = $('tr.new-item').clone(true);
	$newRowTemplate.find('input:not([type="checkbox"])').prop('value', '');

	// Beim Seitenladen einmal auf zwischengespeicherte Eingaben prüfen
	$(function () {
		$('.new-item > td:first-child input').first().trigger('blur');
	});

	function enableTab(id, checkCallback, ajaxCallback)
	{
		var $tab = $(document.getElementById(id));
		var $tabbtn = $('a[data-toggle="tab"][aria-controls]').filter(function () {
			return this.getAttribute('aria-controls') == id;
		}).closest('li');

		var isFresh = (checkCallback) ? checkCallback.call($tab[0], $tab) : true;
		if (isFresh) {
			$tab.find('fieldset').prop('disabled', false);
			$tabbtn.removeClass('hidden');
		}
		else {
			ajaxCallback.call($tab[0], $tab).done(function (data, status, xhr) {
				$tab.html(data);
				$tab.find('fieldset').prop('disabled', false);
				$tabbtn.removeClass('hidden');
			});
		}
	}

	function disableTab(id)
	{
		var $tab = $(document.getElementById(id));
		var $tabbtn = $('a[data-toggle="tab"][href]').filter(function () {
			return this.getAttribute('href') == '#'+id;
		}).closest('li');

		$tab.find('fieldset').prop('disabled', true);
		$tabbtn.addClass('hidden');
	}

	// Änderungen des Vendors beachten, ggf. Vendor-ID bestimmen
	var tcfVendorInput = document.getElementById('tcf_vendor_id');
	var vendorNameInput = document.getElementById('embedding_vendor');
	$(vendorNameInput).on('change blur', function (evt) {
		var $tcfVendors = $('#tcf-vendors');
		var name = this.value;
		tcfVendorInput.value = '';
		$tcfVendors.children('option').each(function () {
			if (this.value == name) {
				tcfVendorInput.value = this.getAttribute('data-id');
			}
		});

		$('#tcf-marker').parent().toggleClass('hide-addon', !tcfVendorInput.value);

		$(tcfVendorInput).trigger('change');

		if (name.search(/google/i) > -1) {
			enableTab('tab-gcm', function () { return this.children.length > 0; }, function ($tab) {
				return $.ajax($tab.attr('data-url'), {
					dataType: 'html'
				});
			});
		} else {
			disableTab('tab-gcm');
		}
	});
	var timeoutHandle = null;
	var timeoutValue = null;
	$(vendorNameInput).closest('.input-group').on('keydown mousedown', '*', function (evt) {
		if (timeoutHandle === null) {
			if (evt.code == 'Enter' || evt.code == 'NumpadEnter') {
				timeoutValue = null;
			} else {
				timeoutValue = vendorNameInput.value;
			}
		}
	}).on('keyup click', '*', function (evt) {
		if (timeoutHandle !== null) {
			clearTimeout(timeoutHandle);
		}
		timeoutHandle = setTimeout(function () {
			if (vendorNameInput.value !== timeoutValue) {
				$(vendorNameInput).trigger('change');
			};
			timeoutHandle = timeoutValue = null;
		}, 250);
	});

	function onTcfVendorChange() {
		if ($('#tab-tcf').length == 0) {
			return;
		}

		if (this.value) {
			var tcfId = this.value;

			enableTab('tab-tcf', function ($tab) {
				var $fieldset = $tab.find('fieldset');
				return ($fieldset.length && $fieldset.attr('data-vendor') == this.value);
			}, function ($tab) {
				return $.ajax($tab.attr('data-url-template').replace('_ID_', tcfId), {
					dataType: 'html'
				});
			});
		} else {
			disableTab('tab-tcf');
		}
	}
	$('#tcf_vendor_id').on('change', onTcfVendorChange);

	$(function () {
		$('#tcf_vendor_id').trigger('change');
		$(vendorNameInput).trigger('change');
	});

	function updateInput(name, value)
	{
		var elements = document.querySelectorAll('[name^="'+name+'"]');

		if (elements.length == 0) {
			return;
		}
		var input = elements[0];

		// Abort if the input field is locked
		var updateLockName = name;
		if (name === 'legal_basis_structured') {
			updateLockName = 'structured_legal_basis';
		}

		var updateLock = document.getElementById('updateParameterBlacklist-' + updateLockName);
		if (updateLock && updateLock.checked) {
			return false;
		}

		// Convert value if necessary
		if (value !== null && typeof value === 'object') {
			if ('date' in value) {
				value = value.date.split('.')[0];
			} else {
				return false; // Cannot handle this value
			}
		} else if (value === null) {
			value = '';
		}

		var tagName = input.tagName.toLowerCase();
		if (tagName == 'textarea' || tagName == 'select' || (tagName == 'input' && input.type !== 'checkbox' && input.type !== 'radio')) {
			if (value != input.value && (typeof value !== 'string' || input.value.trim().replace(/\r\n/g, "\n") != value.trim().replace(/\r\n/g, "\n"))) {
				var isTypeahead = input.classList.contains('tt-input');
				input.value = value;
				$(input).trigger('change');
				if (!isTypeahead) {
					$(input).trigger('blur');
				}
				window.setTimeout(function () {
					if (isTypeahead) {
						input.parentNode.classList.add('updated');
					}
					input.classList.add('updated');
				}, 10);
				return true;
			}
		}
		else if (tagName == 'input' && input.type === 'checkbox') {
			if (input.checked != !!value) {
				input.checked = !!value;
				$(input).trigger('change');
				$(input).trigger('blur');
				input.classList.add('updated');
				return true;
			}
		}
		else if (tagName == 'input' && input.type === 'radio') {
			for (var i = 0; i < elements.length; ++i) {
				if (elements[i].value == value) {
					if (elements[i].checked != true) {
						input.checked = true;
						input.classList.add('updated');
						$(input).trigger('blur');
						return true;
					}
				}
			}
		}
		return false;
	}

	function updateMessage(message)
	{
		if (updateMessage.handle) {
			clearTimeout(updateMessage.handle);
			updateMessage.handle = null;
			if (!message) {
				$('#manual-embedding-update').popover('hide');
			}
		}
		$('#manual-embedding-update').attr('data-content', message);
		$('#manual-embedding-update').popover('show');
		updateMessage.handle = setTimeout(function(){
			$('#manual-embedding-update').popover('hide');
			updateMessage.handle = null;
		}, 6000);
	}
	updateMessage.handle = null;

	$('#manual-embedding-update').on('click', function () {
		var $icon = $(this).find('i');
		var button = this;
		var message = this.getAttribute('data-success-msg');
		var message_unchanged = this.getAttribute('data-unchanged-msg');
		$icon.addClass('fa-spinner fa-spin');
		$.ajax(this.getAttribute('data-url'), {
			dataType: 'json'
		}).done(function (data) {
			var counter = 0;
			for (var key in data) {
				// Simple values
				if (updateInput(key, data[key])) {
					counter++;
				} else if (data[key] !== null && typeof data[key] === 'object') {
					// Localized values
					if ('en_US' in data[key] || 'de_DE' in data[key]) {
						for (var langkey in data[key]) {
							if (updateInput(key+'['+langkey+']', data[key][langkey])) {
								counter++;
							}
						}
					}

					// Multiselect values
					for (var kind in data[key]) {
						if (!Array.isArray(data[key][kind])) {
							continue;
						}

						/** @type {Array.<string>} */
						var values = data[key][kind]
							.filter(function (x) { return ['number', 'string'].includes(typeof x); })
							.map(function (x) { return String(x); });

						name = key + '[' + kind + '][]';
						Array.prototype.slice.call(document.querySelectorAll('select.multiselect[multiple][name="' + name + '"]'))
							.forEach(/** @param {HTMLSelectElement} select */function (select) {
								var updated = false;
								for (var i = 0; i < select.options.length; i++) {
									var newState = values.includes(select.options[i].value);
									if (select.options[i].selected != newState) {
										select.options[i].selected = newState;
										updated = true;
									}
								}
								if (updated) {
									// Check, if the input field is locked
									var updateLock = document.getElementById('updateParameterBlacklist-' + key);
									if (!updateLock || !updateLock.checked) {
										try {
											$(select).trigger('change'); // Notify select2 that the selection has changed
										} catch (_) {}
										counter++;
									}
								}
							});
					}
				}
			}
			// Clear new assets
			var $assetContainer = $('#tab-assets');
			var $assetMainContainer = $assetContainer.find('.asset-table-main');
			$assetContainer.find('table').each(function () {
				$(this).find('tr.new-item').slice(1).remove();
			});

			// Update assets
			var assets = data.add_asset;
			var usedRows = {};
			for (var i = 0; i < assets.length; ++i) {
				var asset = assets[i];
				var $assetNameInput = $assetMainContainer.find('tbody tr td:first-child input[name^="asset"]').filter(function (_, input) { return input.value == asset.name; });
				var $assetRow = $assetNameInput.closest('tr');
				// If two assets have the same name, choose the first one with the right storage type
				if ($assetRow.length > 1) {
					$assetRow.filter(function (_, row) {
						$(row).find('select[name$="[storageType]"]').prop('value') == asset.storageType
					});
				}
				$assetRow = $assetRow.first();
				var prefix;
				// If row found, reuse it
				if ($assetRow.length > 0) {
					usedRows[$assetRow.index()] = $assetRow[0];
					var name = $assetRow.find('input[name$="[name]"]').prop('name');
					prefix = name.substr(0, name.length - 6);
				}
				// Else create new asset
				else {
					$assetRow = $assetMainContainer.find('tr.new-item').last();
					var $nameElement = $assetRow.find('input[name$="[name]"]');
					var name = $nameElement.prop('name');
					prefix = name.substr(0, name.length - 6);
					updateInput(name, asset.name);
					onNewPlaceholderBlur.call($nameElement[0]);
				}
				for (var key in asset) {
					if (key !== 'name') {
						if (updateInput(prefix+'['+key+']', asset[key])) {
							counter++;
						}
					}
					// Localized values
					if (typeof asset[key] === 'object' && ('en_US' in asset[key] || 'de_DE' in asset[key])) {
						for (var langkey in asset[key]) {
							if (updateInput(prefix+'['+key+']['+langkey+']', asset[key][langkey])) {
								counter++;
							}
						}
					}
				}
			}
			// Remove unused assets
			$assetMainContainer.find('tbody > tr').filter(':not(.new-item)').filter(function (index) {
				return !(index in usedRows);
			}).each(onDeleteClick);

			if (counter) {
				var ts = new Date(data.source_ts.date);
				$('date.sourceTS').text(ts.toLocaleDateString()).css('font-weight', 'bold').attr('datetime', ts.toISOString().split('T')[0]);
			}

			updateMessage((counter > 0) ? message : message_unchanged);
		}).always(function () {
			$icon.removeClass('fa-spinner fa-spin');
		});
	}).popover({
		trigger: 'manual',
		placement: 'bottom',
		html: 'true',
		container: $('#manual-embedding-update').closest('.form-group')
	});

	$('main form').on('change input','input.updated, select.updated, textarea.updated', function () {
		this.classList.remove('updated');
		this.parentNode.classList.remove('updated');
	});
	$('main form').on('click', 'input[type="checkbox"].updated, input[type="radio"]', function () {
		this.classList.remove('updated');
	});

})();
