'use strict';

(function () {
	function setValue(field, value) {
		if (field instanceof HTMLInputElement
			|| field instanceof HTMLTextAreaElement
		) {
			field.value = value;
		}
		else {
			throw new Error('Field type "' + ('constructor' in field ? field.constructor.name : field) + '" not supported.');
		}
	}

	function fillFromLocale(ajaxUrl) {
		$.ajax(ajaxUrl, {
			dataType: 'json',
		}).done(function (data) {
			for (var name in data) {
				Array.prototype.slice.call(document.getElementsByName(name)).forEach(function (field) {
					setValue(field, data[name]);
				});
			}
		});
	}

	function onFillFromLocaleButtonClicked(event) {
		/** @type {HTMLSelectElement} */
		var locale = document.getElementById(this.dataset.fillFromLocale);
		if (!locale || !locale.value) {
			return;
		}

		var ajaxUrl = String(this.dataset.ajaxUrl || '').replace(':localeName', locale.value);

		fillFromLocale(ajaxUrl);
	}

	window.addEventListener('DOMContentLoaded', function () {
		Array.prototype.slice.call(document.querySelectorAll('[data-fill-from-locale][data-ajax-url]')).forEach(function (button) {
			button.addEventListener('click', onFillFromLocaleButtonClicked);
		});
	});
})();
