<?php
namespace App\Command\Env;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

class AllCommand extends Command
{
	// the name of the command (the part after "bin/console")
	protected static $defaultName = 'app:env:all';

	protected function configure(): void
	{
		$this
			->setDescription('Show environment variables.')
			->setDefinition([])
		;
	}


	protected function execute(InputInterface $input, OutputInterface $output): int
	{
		$io = new SymfonyStyle($input, $output);

		$keys = $_ENV['SYMFONY_DOTENV_VARS'] ?? '';
		$keys = $keys ? explode(',', $keys) : [];

		$result = [];
		foreach ($keys as $key) {
			$result[] = [$key => htmlspecialchars(($_ENV[$key] ?? ''))];
		}
		call_user_func_array([$io, 'definitionList'], $result);

		return 0;
	}
}
