<?php
namespace App\Command\Env;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class GetCommand extends Command
{
	// the name of the command (the part after "bin/console")
	protected static $defaultName = 'app:env:get';

	protected function configure(): void
	{
		$this
			->setDescription('Get an environment variable.')
			->setDefinition([
				new InputArgument('key', InputArgument::REQUIRED),
			])
		;
	}

	protected function execute(InputInterface $input, OutputInterface $output): int
	{
		$output->writeln($_ENV[$input->getArgument('key')] ?? '');
		return 0;
	}
}
