<?php
namespace App\Command\Update;

use App\Component\Update;
use App\Utils;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

class ReinstallCommand extends Command
{
	// the name of the command (the part after "bin/console")
	protected static $defaultName = 'app:reinstall';

	/** @var Update $updater */
	private $updater;

	public function __construct(Update $updater)
	{
		$this->updater = $updater;
		parent::__construct();
	}

	protected function configure(): void
	{
		$this
			->setDefinition([])
			->setDescription('Download and reinstall the currently installed')
		;
	}

	protected function execute(InputInterface $input, OutputInterface $output): int
	{
		$io = new SymfonyStyle($input, $output);

		// Versions holen
		$versionId = Utils::getVersionId();

		$io->comment('Reinstalling version '.$versionId);

		$updateCmd = new UpdateCommand($this->updater);
		return $updateCmd->perform($io, $versionId, false, false);
	}
}
