<?php

namespace App\Component\Api\Exception;

use RuntimeException;
use Symfony\Component\HttpFoundation\JsonResponse;
use Throwable;

class BadRequestException extends RuntimeException
{
	/** @var JsonResponse $response */
	private $response;

	/**
	 * @param JsonResponse $response
	 * @param Throwable|null $previous
	 */
	public function __construct(JsonResponse $response, ?Throwable $previous=null)
	{
		parent::__construct('Read `$exception->getResponse()` for further details.', 0, $previous);

		$this->response = $response;
	}

	/**
	 * @return JsonResponse
	 */
	public function getResponse(): JsonResponse
	{
		return $this->response;
	}
}
