<?php

namespace App\Component\Config;

interface ModelInterface
{
	/**
	 * @param string $id
	 * @return bool
	 * @phan-side-effect-free
	 */
	public static function exists(string $id): bool;

	/**
	 * @param string $id
	 * @return static|null
	 * @phan-side-effect-free
	 */
	public static function find(string $id);

	/**
	 * @return static[]
	 * @phan-side-effect-free
	 */
	public static function all(): array;

	/**
	 * Zählt die vorhandenen Instanzen dieses Models.
	 * @return int
	 * @phan-side-effect-free
	 */
	public static function count(): int;

	/**
	 * @return string
	 * @phan-side-effect-free
	 */
	public function getId(): string;

	/**
	 * Größe des Repositories auf der Festplatte in Bytes, ohne ungespeicherte Änderungen
	 *
	 * @return int Größe in Bytes (-1 wenn nicht vom Repository unterstützt)
	 * @phan-side-effect-free
	 */
	public static function persistedRepositorySize(): int;
}
