<?php

namespace App\Component\Cron\Job;

use App\Component\Cron\DomainJob;
use App\Model\Domain;
use App\Model\ProtocolArchive;
use Symfony\Component\HttpFoundation\Request;
use DateTime;

class ProtocolArchiveCleanup extends DomainJob
{
	const CUTOFF_TIMESPEC = '- 385 days midnight';

	public function __construct()
	{
		parent::__construct(72 * 60 * 60);
	}

	public function run(Request $request): void
	{
		$this->touchLastExecutionTimestamp();
		ProtocolArchive::byDomain(Domain::activeDomain())->deleteAllBefore(new DateTime(self::CUTOFF_TIMESPEC));
	}
}
