<?php
namespace App\Component\Licensing;

/**
 * Informationen zu einer Lizenz
 *
 * @see ApiClient::registerLicense()
 */
final class LicenseInfo {
	/** @var bool $active */
	public $active = true;
	/** @var string $domain */
	public $domain = '';
	/** @var string $edition */
	public $edition = '';
	/** @var int $limit */
	public $limit = 0;
	/** @var bool $whitelabel */
	public $whitelabel = false;
	/** @var int $maxcalls */
	public $maxcalls = -1;
	/** @var string $tarif */
	public $tarif = "free";

	public static function fromArray(array $data) {
		$result = new self;
		$result->active = (bool)($data['active'] ?? true);
		$result->domain = (string)($data['dom'] ?? '');
		$result->edition = (string)($data['edition'] ?? '');
		$result->limit = max(-1, (int)($data['limit'] ?? -1));
		$result->whitelabel = (bool)($data['whitelabel'] ?? false);
		$result->maxcalls = max(-1, (int)($data['maxcalls'] ?? -1));
		$result->tarif = (string)($data['tarif'] ?? '');
		return $result;
	}
}
