<?php
namespace App\Component\Licensing;

/**
 * Informationen zu einer Whitelabel-Lizenz
 *
 * @see ApiClient::registerWhitelabel()
 * @see ApiClient::unregisterWhitelabel()
 */
final class WhitelabelInfo {
	/** @var string $domain */
	public $domain = '';
	/** @var string $edition */
	public $edition = '';
	/** @var bool $whitelabel */
	public $whitelabel = false;
	/** @var int $whitelabelCount */
	public $whitelabelCount = 0;
	/** @var int $whitelabelMaxCount */
	public $whitelabelMaxCount = 0;

	public static function fromArray(array $data) {
		$result = new self;
		$result->domain = (string)($data['domain'] ?? '');
		$result->edition = (string)($data['edition'] ?? '');
		$result->whitelabel = (bool)($data['whitelabel'] ?? false);
		$result->whitelabelCount = (int)($data['whitelabelCount'] ?? 0);
		$result->whitelabelMaxCount = (int)($data['whitelabelMaxCount'] ?? 0);
		return $result;
	}
}
