<?php

namespace App\Component\Tcf\v2;

use App\Component\Tcf\v2\Model\Vendor;

final class ExtendedDisclosureRepository extends Repository
{
	/**
	 * @override
	 * @return string[]
	 */
	protected function getDownloadUrls(): array
	{

		$match = [];
		preg_match('/^deviceStorage-([0-9]+)\.json/i', $this->filename, $match);

		if (!$match) {
			return [];
		}

		if (!empty($_ENV['TCF_STORAGE_DISCLOSURE_PROXY'])) {
			return [$_ENV['TCF_STORAGE_DISCLOSURE_PROXY'].'/'.$match[1].'.json'];
		} else {
			$vendor = Vendor::find($match[1]);
			if (!$vendor) {
				return [];
			}

			return [(string)$vendor->getDeviceStorageDisclosureUrl()];
		}
	}
}
