<?php

namespace App\Component\Tcf\v2\Model\Translation;

class Feature extends Model
{
	protected static $repositoryKey = 'features';

	public function getName(): string
	{
		return $this->get('name');
	}

	public function getDescription(): string
	{
		return $this->get('description');
	}

	/** @deprecated Seit TCFv2.2 */
	public function getLegalDescription(): string
	{
		return (string)$this->get('descriptionLegal');
	}

	/** neu in TCFv2.2
	 * @return string[]
	 */
	public function getIllustrations(): array
	{
		return array_filter($this->get('illustrations', []));
	}

	public function __toString(): string
	{
		return sprintf('[TCFv2 Feature Translation %1 %2: "%3"]', $this->getLanguage(), $this->getId(), $this->getName());
	}
}
