<?php

namespace App\Component\ThumbnailExtractor;

#[\AllowDynamicProperties]
class ThumbnailInformation implements \JsonSerializable
{
	/** @var string $originalUrl */
	public $originalUrl = '';

	/** @var string $path */
	public $path = '';

	/** @var string $etag */
	public $etag = '';

	/** @var ?int */
	public $width = null;

	/**
	 * @param array $data
	 */
	public function __construct($data=[])
	{
		$cache_path = ThumbnailExtractorService::getCacheDir() . '/';
		foreach ($data as $key => $value) {
			if ($key === 'path' and $value) {
				$value = $cache_path . $value;
			}
			$this->{$key} = $value;
		}
	}

	/**
	 * @return array<string,mixed>
	 */
	#[\ReturnTypeWillChange]
	public function jsonSerialize() {
		$data = (array)$this;
		$data['path'] = substr($data['path'], strlen(ThumbnailExtractorService::getCacheDir() . '/'));
		return $data;
	}

}
