<?php

namespace App\Controller;

use App\Component\Menu\Annotation\Menu;
use App\Model\User;
use App\Model\CsrfToken;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class ApiKey extends AbstractController
{
	/**
	 * @Menu("Domain API", group="Settings", icon="fa-cloud", order=70)
	 * @Route("/apikey", name="app_apikey", methods={"HEAD", "GET", "POST"})
	 * @param Request $request
	 * @return Response
	 */
	public function index(Request $request): Response
	{
		//user ini
		$user = User::loggedInUser()->getAccountOwner();

		//Wenn Button gedrückt - der ist rot :-) - dann wird ein neuer Key erzeugt...
		if ($request->request->getAlnum("action") === 'reset' or empty($user->getGeneralApiKey())) {
			$user->generateGeneralApiKey();
			$user->flush();
		}

		//Ausgabe der Daten
		return $this->render('apikey/index.html.twig', [
			'csrfToken' => CsrfToken::get(),
			'apiKey' => $user->getGeneralApiKey()
		]);
	}



}
