<?php

namespace App\Event;

use Symfony\Contracts\EventDispatcher\Event;

final class CacheResetEvent extends Event
{
	const NAME = 'ccm19.cache.reset';

	/** @var string[] $relevantModels */
	private $relevantModels;

	public function __construct()
	{
		$this->relevantModels = [];
	}

	/**
	 * @param string $className
	 * @return $this
	 */
	public function addRelevantModel(string $className): self
	{
		$this->relevantModels[$className] = $className;
		return $this;
	}

	/**
	 * @return string[]
	 */
	public function getRelevantModels(): array
	{
		return $this->relevantModels;
	}
}
