<?php

namespace App\Event;

use App\Model\Domain;
use Symfony\Contracts\EventDispatcher\Event;

final class DomainInitializedEvent extends Event
{
	const NAME = 'ccm19.modelInitialized.domain';

	/** @var Domain $domain */
	private $domain;

	/**
	 * @param Domain $domain
	 */
	public function __construct(Domain $domain)
	{
		$this->domain = $domain;
	}

	/**
	 * @return Domain
	 */
	public function getDomain(): Domain
	{
		return $this->domain;
	}
}
