<?php
namespace App\Event;

use Symfony\Contracts\EventDispatcher\Event;

/** @template T */
class FilterEvent extends Event
{
	/** @var T $returnValue */
	protected $returnValue;

	/** @param T $return */
	public function __construct($return)
	{
		$this->returnValue = $return;
	}

	/** @return T */
	public function getReturn()
	{
		return $this->returnValue;
	}

	/**
	 * @param T $return
	 * @return $this
	 */
	public function setReturn($return): self
	{
		$this->returnValue = $return;
		return $this;
	}
}
