<?php

namespace App\Exception;

use RuntimeException;
use Throwable;
use App\Model\User;

class SecondFactorRequiredException extends RuntimeException
{
	/** @var User $user */
	private $user;
	/** @var array[] $methods */
	private $methods;

	public function __construct(User $user, array $methods, Throwable $previous = null)
	{
		parent::__construct("User ".$user->getUsername()." needs Two Factor Authentication.", 0, $previous);
		$this->user = $user;
		$this->methods = $methods;
	}

	public function getUser(): User
	{
		return $this->user;
	}

	public function getMethods(): array
	{
		return $this->methods;
	}
}
