<?php

namespace App\Exception;

use RuntimeException;
use Throwable;

class UserIsDeactivatedException extends RuntimeException
{
	private $extendedReason;

	public function __construct(string $username, ?string $extendedReason = null, int $code = 0, Throwable $previous = null)
	{
		parent::__construct('User is deactivated from logging into the system.', $code, $previous);
		$this->extendedReason = $extendedReason;
	}

	public function getExtendedReason(): ?string
	{
		return $this->extendedReason;
	}
}
