<?php

namespace App\Model\Regulations;

use App\Component\EmbeddingDb\Repository;

class Article extends Model
{
	protected static $repositoryFilename = 'regulations';

	/** @var Repository|null $repository */
	protected static $repository = null;

	public function getText(string $langCode = 'en'): string
	{
		return (string)$this->getTranslated('text', $langCode, '');
	}

	public function getDescription(string $langCode = 'en'): string
	{
		return (string)$this->getTranslated('desc', $langCode, '');
	}

	public function getGroup(): ?Group
	{
		$id = $this->get('group', 0);
		if ($id) {
			return Group::find($id);
		} else {
			return null;
		}
	}

	// TODO: Overrides für Länder/Regionen

	public function __toString(): string
	{
		return sprintf('[Regulation article %s: "%s"]', $this->getId(), $this->getText());
	}
}
