<?php

namespace App\Model;

use App\Component\Config\RepositoryInterface;

class SystemEmbeddingAsset extends EmbeddingAssetBase
{
	/** @var RepositoryInterface|null $repository */
	protected static $repository = null;

	/**
	 * @param string $id
	 */
	protected function __construct(string $id)
	{
		parent::__construct($id);
	}

	public function getTranslatedDescription(Language $language, bool $useFallback=true): string
	{
		$result = $this->get('translated_description.'.$language->getCode());
		if ($useFallback and ($result === null or $result === '')) {
			return $this->getDescription();
		}
		return (string)$result;
	}

	/**
	 * @param Language $language
	 * @param string $description
	 * @return $this
	 */
	public function setTranslatedDescription(Language $language, string $description): self
	{
		$this->set('translated_description.'.$language->getCode(), $description);
		return $this;
	}

	public function getTranslatedLifetime(Language $language, bool $useFallback=true): string
	{
		$result = $this->get('translated_lifetime.'.$language->getCode());
		if ($useFallback and ($result === null or $result === '')) {
			return $this->getLifetime();
		}
		return (string)$result;
	}

	/**
	 * @param Language $language
	 * @param string $lifetime
	 * @return $this
	 */
	public function setTranslatedLifetime(Language $language, string $lifetime): self
	{
		$this->set('translated_lifetime.'.$language->getCode(), $lifetime);
		return $this;
	}
}
